Angular - Documentation | www.HtmlElements.com

Using Custom Elements with Angular

What is Angular?

Angular is a platform that makes it easy to build applications with the web. Angular combines declarative templates, dependency injection, end to end tooling, and integrated best practices to solve development challenges. Angular empowers developers to build applications that live on the web, mobile, or the desktop

How to use Custom Elements with Angular?

The only Angular-specific step we need to take to make Angular play well with Web Components is to add the CUSTOM_ELEMENTS_SCHEMA to our app module and import our Smart Elements

.
	import { NgModule, CUSTOM_ELEMENTS_SCHEMA  } from '@angular/core';
	import { BrowserModule } from '@angular/platform-browser'; 
	import { FormsModule } from '@angular/forms';

	import { AppComponent } from './app.component';
	import '@smarthtmlelements/smart-core/source/smart.core.js';

	@NgModule({
		declarations: [AppComponent],
		imports: [BrowserModule, FormsModule],
		schemas: [ CUSTOM_ELEMENTS_SCHEMA ],
		providers: [],
		bootstrap: [AppComponent]
	})

	export class AppModule { }
	

We can now use our custom element as if it was just a native html element. Data binding and event handlers will just work right out of the box.

Example

Here’s how we would use our Smart.ListBox element as part of a simple Angular app. First, our component template:

app.component.html


	 <smart-list-box [selectionMode]="selectionMode">   
		  <smart-list-item value="United Kingdom">United Kingdom</smart-list-item>  
		  <smart-list-item value="United States">United States</smart-list-item>  
		  <smart-list-item value="United States Minor Outlying Islands">United States Minor Outlying Islands</smart-list-item>  
	 </smart-list-box>  
	


We have bound the selectionMode property of our custom element to dynamic values in our Angular component

app.component.ts

	import { Component, ViewChild, AfterViewInit } from '@angular/core';

	@Component({
		selector: 'app-root',
		templateUrl: './app.component.html'
	})

	export class AppComponent implements AfterViewInit {
		selectionMode: string = 'checkBox';
		
		ngAfterViewInit(): void {

		}
	}
	

Note: In the package.json, you should include a dependency to Smart's npm package. Ex: "@smarthtmlelements/smart-core": "2.0.0"
Download our example from here:
angular-sample.zip.

Using Vue 2 with Smart UI - Documentation | www.HtmlElements.com


Vue & Web Components


Vue is a framework focused on the view layer, helping the development of applications based on components. This page will show you how to use Smart Web Components with Vue.



Overview


We will walk you through the steps to add Smart Web Components to an existing Vue project, and configure some of the features. Smart web Components contains 40+ Web Components with Material Design. Some of the web components are: Grid, Chart, Gannt Chart, Docking Layout. For the purposes of the demo, we will use the Grid web component. We will show you some of the data grid capabilities (properties, data source). In addition, we will customize the Grid appearance with custom Column Templates.



Table of Contents

Add "smart-grid" to Your Vue Project


Creating projects with vue-cli

Let's install vue-cli


npm install -g @vue/cli

Then we can start creating our Vue.js projects with:


vue create my-project

Install Smart Web Components

Open the "my-project" folder and run:

npm install @smarthtmlelements/smart-elements

Ignored Elements

Make Vue ignore custom elements defined outside of Vue (e.g., using the Web Components APIs). Otherwise, it will throw a warning about an Unknown custom element, assuming that you forgot to register a global component or misspelled a component name.

Open src/main.js in your favorite text editor and change its contents to the following:

import Vue from 'vue'
import App from './App.vue'

Vue.config.productionTip = false
Vue.config.ignoredElements = [
  'smart-grid'
]

new Vue({
  render: h => h(App),
}).$mount('#app')

Open src/App.vue in your favorite text editor and change its contents to the following:

App.vue

 <template>  
  <smart-grid id="grid"></smart-grid>  
 </template>   
 <script>  
 import "@smarthtmlelements/smart-elements/source/styles/smart.default.css";  
 import '@smarthtmlelements/smart-elements/source/modules/smart.grid.js';  
 export default {  
  name: "app",  
  mounted: function() {  
   window.Smart(  
    "#grid", class {  
     get properties() {  
           return {  
                columns: [  
                     {  
                          label: 'First Name', dataField: 'firstName'  
                     },  
                     { label: 'Last Name', dataField: 'lastName' },  
                     { label: 'Product', dataField: 'productName' }  
                ],  
                dataSource: new window.Smart.DataAdapter(  
                {  
                     dataSource: [  
                          { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
                          { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
                          { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
                          { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
                          { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
                          { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
                          { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
                          { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
                          { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
                          { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
                          { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
                          { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
                          { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
                     ],  
                     dataFields:  
                     [  
                          'firstName: string',  
                          'lastName: string',  
                          'productName: string'                           
                     ]  
                })  
           }  
     }  
    }  
   );  
  }  
 };  
 </script>  
 <style>  
  body {  
   min-height: 700px;  
  }  
  smart-grid {  
   width: 100%;  
   height: auto;  
  }  
 </style>  
We can now use the smart-grid with Vue. Data binding and event handlers will just work right out of the box.
We have bound the "columns" and "dataSource" properties of the smart-grid to values in our Vue component.
Result:

Vue Grid

Add Sorting and Filtering


Sorting and Filtering are essential features in each web application with Grids. To enable the sorting and filtering in our grid, we need to define two objects - sorting and filtering and set the "enabled" boolean property to true. We add the below code to the Smart function defined in the App.vue

 <template>  
  <smart-grid id="grid"></smart-grid>  
 </template>   
 <script>  
 import "@smarthtmlelements/smart-elements/source/styles/smart.default.css";  
 import '@smarthtmlelements/smart-elements/source/modules/smart.grid.js';  
 export default {  
  name: "app",  
  mounted: function() {  
   window.Smart(  
    "#grid", class {  
     get properties() {  
           return {  
                columns: [  
                     {  
                          label: 'First Name', dataField: 'firstName'  
                     },  
                     { label: 'Last Name', dataField: 'lastName' },  
                     { label: 'Product', dataField: 'productName' }  
                ],  
				sorting: {
					enabled: true
				},	
				filtering: {
					enabled: true
				},				
                dataSource: new window.Smart.DataAdapter(  
                {  
                     dataSource: [  
                          { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
                          { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
                          { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
                          { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
                          { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
                          { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
                          { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
                          { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
                          { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
                          { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
                          { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
                          { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
                          { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
                     ],  
                     dataFields:  
                     [  
                          'firstName: string',  
                          'lastName: string',  
                          'productName: string'                           
                     ]  
                })  
           }  
     }  
    }  
   );  
  }  
 };  
 </script>  
 <style>  
  body {  
   min-height: 700px;  
  }  
  smart-grid {  
   width: 100%;  
   height: auto;  
  }  
 </style>  

Vue Grid Sort and Filter

Online Examples: Grid Sorting and Grid Filtering

Enable Selection


The Grid supports selection by cell, row and with checkboxes. We can also choose from selection with single and double-click, selection by one or multiple rows or cells. In the code below, we will enable the Row selection. We add the below code to the Smart funtion App.vue

	selection: {
		enabled: true
	}
Online Selection Example: Grid Selection.


Add Grouping(Professional)


Grouping is a professional feature and requires a license. The comparison table with features and components included in the Community and Professional versions is here. Similar to Sorting and Filtering, Grouping is enabled by setting the "enabled" property to true

We add the below code to App.vue

	grouping: {
		enabled: true
	}

App.vue

 <template>  
  <smart-grid id="grid"></smart-grid>  
 </template>   
 <script>  
 import "@smarthtmlelements/smart-elements/source/styles/smart.default.css";  
 import '@smarthtmlelements/smart-elements/source/modules/smart.grid.js';  
 export default {  
  name: "app",  
  mounted: function() {  
   window.Smart(  
    "#grid", class {  
     get properties() {  
           return {  
                columns: [  
                     {  
                          label: 'First Name', dataField: 'firstName'  
                     },  
                     { label: 'Last Name', dataField: 'lastName' },  
                     { label: 'Product', dataField: 'productName' }  
                ],  
				grouping: {
					enabled: true
				},
				sorting: {
					enabled: true
				},	
				filtering: {
					enabled: true
				},				
                dataSource: new window.Smart.DataAdapter(  
                {  
                     dataSource: [  
                          { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
                          { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
                          { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
                          { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
                          { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
                          { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
                          { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
                          { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
                          { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
                          { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
                          { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
                          { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
                          { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
                     ],  
                     dataFields:  
                     [  
                          'firstName: string',  
                          'lastName: string',  
                          'productName: string'                           
                     ]  
                })  
           }  
     }  
    }  
   );  
  }  
 };  
 </script>  
 <style>  
  body {  
   min-height: 700px;  
  }  
  smart-grid {  
   width: 100%;  
   height: auto;  
  }  
 </style>  
Vue Grid Web Component Grouping

Online Grouping Example: Grid Grouping.



Enable Editing


smart-grid supports editing by cell, editing by row(Professional) and editing with dialog or command column(Professional). In this case, we will use the cell editing. You can enable the editing functionality by setting the "enabled" boolean property to true.

App.vue

	editing: {
		enabled: true
	}


Enable Paging


To enable pagination, set the grid paging and pager properties. The paging.enabled turns on/off pagination, pager.visible shows/hides the top or bottom pagers. The grid's pagination feature can be used to load data on demand. It can be used with all other grid features. There are built-in options to customize the "pageSize", navigate through pages using API, customize the pager's template, configure whether top and bottom pagers are visible all the time or only the top or bottom pager is visible. It is also optional to display a "select" tag to dynamically update the page size or an "input" tag which allows you to type the page index and navigate to the page.

App.vue

 <template>  
  <smart-grid id="grid"></smart-grid>  
 </template>   
 <script>  
 import "@smarthtmlelements/smart-elements/source/styles/smart.default.css";  
 import '@smarthtmlelements/smart-elements/source/modules/smart.grid.js';  
 export default {  
  name: "app",  
  mounted: function() {  
   window.Smart(  
    "#grid", class {  
     get properties() {  
           return {  
                columns: [  
                     {  
                          label: 'First Name', dataField: 'firstName'  
                     },  
                     { label: 'Last Name', dataField: 'lastName' },  
                     { label: 'Product', dataField: 'productName' }  
                ],  
				grouping: {
					enabled: true
				},
				paging: {
					enabled: true
				},
				pager: {
					visible: true
				},
				selection: {
					enabled: true
				},
				sorting: {
					enabled: true
				},	
				filtering: {
					enabled: true
				},				
                dataSource: new window.Smart.DataAdapter(  
                {  
                     dataSource: [  
                          { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
                          { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
                          { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
                          { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
                          { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
                          { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
                          { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
                          { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
                          { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
                          { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
                          { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
                          { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
                          { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
                     ],  
                     dataFields:  
                     [  
                          'firstName: string',  
                          'lastName: string',  
                          'productName: string'                           
                     ]  
                })  
           }  
     }  
    }  
   );  
  }  
 };  
 </script>  
 <style>  
  body {  
   min-height: 700px;  
  }  
  smart-grid {  
   width: 100%;  
   height: auto;  
  }  
 </style>  


Set Theme


The Smart Web Components product includes 14 Material Themes - 7 Light and 7 Dark. To set a theme, just include the "smart.[theme].css" file after smart.default.css and set your component's theme attribute to the theme name.


Vue Grid Web Component Dark

If you would like to customize or build a custom theme, you can use our Online Theme Builder web application.

Summary


You just learned how to setup an Vue project and add a Grid Web Component with Sorting, Filtering, Grouping and Selection. To learn more about the Grid component, visit: Grid Demos and Documentation. If you want to learn more: https://www.htmlelements.com/docs/vue/


Samples with other web components

React - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

Using with React

1. Installation

The easiest way to start with React is to use NextJS.

npx create-next-app@latest
cd my-app
npm start	

2. Preparation

Open src/page.js

3. Setup

Smart UI for React is distributed as smart-webcomponents-react NPM package

  1. Download and install the package.
    npm install smart-webcomponents-react

2. Add the React Component in src/page.js

import { Accordion, AccordionItem } from 'smart-webcomponents-react/accordion';
import 'smart-webcomponents-react/source/styles/smart.default.css';


3. Add the HTML for the Accordion in src/page.js

page.js

 <Accordion>  
   <AccordionItem label="First Item">First Item Content.</AccordionItem>  
   <AccordionItem label="Second Item">Second Item Content.</AccordionItem>  
   <AccordionItem label="Third Item">Third Item Content.</AccordionItem>  
   <AccordionItem label="Fourth Item">Fourth Item Content.</AccordionItem>  
 </Accordion>  

Start the app with
npm run dev
and open localhost:3000 in your favorite web browser to see the output below:

Create React App The full source code:
import React from 'react';
import styles from './page.module.css';
import { Accordion, AccordionItem } from 'smart-webcomponents-react/accordion';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function Home() {
  return (
	<Accordion>  
	   <AccordionItem label="First Item">First Item Content.</AccordionItem>  
	   <AccordionItem label="Second Item">Second Item Content.</AccordionItem>  
	   <AccordionItem label="Third Item">Third Item Content.</AccordionItem>  
	   <AccordionItem label="Fourth Item">Fourth Item Content.</AccordionItem>  
	</Accordion>  
  );
}

 

Adding Grid

Now, let's build a more advanced example with our Grid component. The Smart.Grid for React is the industry's best data grid component, covering features such as paging, sorting, filtering, editing, grouping, localization. excel and pdf export, import from excel, printing, charting, etc.

Let's add a Smart.Grid component and enable columns hierarchy, sorting, paging, multiple cells selection, column resize and editing.

Add the code below to create a Grid bound to a list of people.

<Grid
	dataSource={this.dataSource}
	columns={this.columns}
	appearance={this.appearance}
	behavior={this.behavior}
	selection={this.selection}
	paging={this.paging}
	pager={this.pager}
	sorting={this.sorting}
	editing={this.editing}
</Grid>

The Grid is databound to a dataAdapter instance which acts as a bridge between the Data and the Smart.Grid for React.
dataSource = [{ "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
	{ "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
	{ "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
	{ "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
	{ "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
	{ "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
	{ "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
	{ "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
	{ "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
	{ "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
	{ "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
	{ "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
	{ "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}]

Below is the columns initialization code. Each column should have "label" and "dataField" props. "label" defines the header text, "dataField" defines the databinding in the data source.


columns = [{
	label: 'First Name',
	dataField: 'firstName'
},
{
	label: 'Last Name',
	dataField: 'lastName'
},
{
	label: 'Product',
	dataField: 'productName'
}
]


Now lets enable resizing, selection, editing and paging in our React Grid.


behavior = {
	columnResizeMode: 'growAndShrink'
}

appearance = {
	alternationCount: 2,
	showRowHeader: true,
	showRowHeaderSelectIcon: true,
	showRowHeaderFocusIcon: true
}

paging = {
	enabled: true
}

pager = {
	visible: true
}

sorting = {
	enabled: true
}

editing = {
	enabled: true
}

selection = {
	enabled: true,
	allowCellSelection: true,
	allowRowHeaderSelection: true,
	allowColumnHeaderSelection: true,
	mode: 'extended'
}

To enable sorting, editing and paging we define objects and set the Grid's "enabled" property to true. The appearance object defines alternating rows appearance. showRowHeader displays the row header cells and the showRowHeaderSelectIcon and showRowHeaderFocusIcon define the row header cells style when the row is selected or focused. The selection object defines a cells selection and enables the row and column headers selection.

Create React App with Grid The full code for the example:
import 'smart-webcomponents-react/source/styles/smart.default.css';
import { Grid } from 'smart-webcomponents-react/grid';

export default function Home() {
	const behavior = {
		columnResizeMode: 'growAndShrink'
	}

	const appearance = {
		alternationCount: 2,
		showRowHeader: true,
		showRowHeaderSelectIcon: true,
		showRowHeaderFocusIcon: true
	}

	const paging = {
		enabled: true
	}

	const pager = {
		visible: true
	}

	const sorting = {
		enabled: true
	}

	const editing = {
		enabled: true
	}

	const selection = {
		enabled: true,
		allowCellSelection: true,
		allowRowHeaderSelection: true,
		allowColumnHeaderSelection: true,
		mode: 'extended'
	}

	const dataSource = [  
		  { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
		  { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
		  { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
		  { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
		  { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
		  { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
		  { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
		  { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
		  { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
		  { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
		  { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
		  { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
		  { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
	]

	const columns = [{
		label: 'First Name',
		dataField: 'firstName'
	},
	{
		label: 'Last Name',
		dataField: 'lastName'
	},
	{
		label: 'Product',
		dataField: 'productName'
	}
	]


		return (
			<div>
				<div>The Grid in this demo displays data in a series of rows and columns. This
			        is the simplest case when the Grid is bound to a local data source.</div>
				<Grid
					dataSource={dataSource}
					columns={columns}
					appearance={appearance}
					behavior={behavior}
					selection={selection}
					paging={paging}
					pager={pager}
					sorting={sorting}
					editing={editing}
					>
				</Grid>
			</div>
		);
}